import pyTTS
import re
import wave
import struct
from logging import *
import os


def tts_wav(text, wav_path):
    tts.SpeakToWave(wav_path, text)
    trim_silence(wav_path)

def trim_silence(filename):
    limit = 200
    w = wave.open(filename)
    start_found = False
    for i in range(w.getnframes()):
        # little endian; 2's complement signed integers (short)
        d = struct.unpack("h", w.readframes(1))[0]
        if not start_found:
            if (d > limit) or (d < -limit):
                start = i
                start_found = True
                end = i
        else:
            if (d > limit) or (d < -limit):
                end = i
    w.rewind()
    w.setpos(start)
    s = w.readframes(end - start)
    w.close()
    w2 = wave.open(filename, "wb")
    w2.setparams(w.getparams())
    w2.writeframes(s)

def build_all_txt(sounds_txt_name, tts):
    for s in open(sounds_txt_name):
        s = s.rstrip("\n")
        if re.match("^[0-9]+[ \t]+.*$", s):
            n, text = s.split(None, 1) # None = "default separator"
            if text[0] in '("':
                continue
            build_txt(n, text, tts)
        elif (s != "") and (s[0] != "#"):
            print "line from %s ignored: %s" % (s, sounds_txt_name)
    for c in string.ascii_lowercase: # letters
        n = string.ascii_lowercase.index(c) + 5000
        text = c
        build_txt(n, text, tts)

def build_txt(n, text, tts):
    filename = os.path.join(dest, "%s.wav" % n)
    if not os.path.exists(filename):
        text = text.replace("...", " ")
        print "%s: \"%s\"" % (filename, text)
        tts(text, filename)


try:
    dest = "sounds"
    if not os.path.exists(dest):
        os.mkdir(dest)
    if os.listdir(dest):
        print "The 'sounds' folder is not empty."
        print "Please empty it, remove it, or rename it."
        print "Then try again."
    else:
        tts = pyTTS.Create()
        names = tts.GetVoiceNames()
        for i, n in enumerate(names):
            print "%s: %s" % (i, n)
        nb = int(raw_input("Enter voice number: "))
        tts.SetVoiceByName(names[nb])
#        default_rate = tts.Rate
        default_rate = 3
        try:
            tts.Rate = int(raw_input("Enter rate (from -10 to 10; default=%s): " % default_rate))
        except:
            tts.Rate = default_rate
        print "rate = %s" % tts.Rate
        build_all_txt("sounds.txt", tts_wav)
except:
    exception("Error")
raw_input("[Press ENTER to quit]")
